=== modified file 'TODO'
--- TODO	2008-08-02 14:33:47 +0000
+++ TODO	2008-08-02 10:48:24 +0000
@@ -1,35 +1,31 @@
--*- org -*-
-
-* Mandos client
-** header files/symbols tally
-** check exit codes of all system calls
-** IPv4 support
-** protocol version header
-** use strsep instead of strtok?
-
-* Pluginbasedclient
-** header files/symbols tally
-** check exit codes of all system calls
-** change uid to nobody:nogroup
-   other drop privs stuff?
-** pass things in environment, like device name, etc
-   Does cryptsetup already do this?
-** use strsep instead of strtok?
-
-* Server
-** config for:
-*** TXT record
-** protocol version header
-** Run-time communication with server
-   probably using D-Bus
-
-* Mandos-tools/utilities
-  All of this probably using D-Bus
-** List clients
-** Enable client
-** Disable client
-
-* Installer
-
-
-#+STARTUP: showall
+[Mandos client]
+configuration for OpenPGP key dir
+header files/symbols tally
+check exit codes of all system calls
+IPv4 support
+protocol version header
+use strsep instead of strtok?
+
+[Pluginbasedclient]
+header files/symbols tally
+check exit codes of all system calls
+change uid to nobody:nogroup
+	other drop privs stuff?
+pass things in environment, like device name, etc
+	Does cryptsetup already do this?
+use strsep instead of strtok?
+
+[Server]
+config for:
+	TXT record
+protocol version header
+Run-time communication with server
+	probably using D-Bus
+
+[Mandos-tools/utilities]
+	List clients
+	Enable client
+	Disable client
+
+[Installer]
+...

=== modified file 'plugbasedclient.c'
--- plugbasedclient.c	2008-08-02 15:47:42 +0000
+++ plugbasedclient.c	2008-08-02 10:48:24 +0000
@@ -160,15 +160,13 @@
   struct stat st;
   fd_set rfds_all;
   int ret, maxfd = 0;
-  uid_t uid = 65534;
-  gid_t gid = 65534;
   bool debug = false;
   int exitstatus = EXIT_SUCCESS;
-  struct sigaction old_sigchld_action;
-  struct sigaction sigchld_action = { .sa_handler = handle_sigchld,
-				      .sa_flags = SA_NOCLDSTOP };
-
+  
   /* Establish a signal handler */
+  struct sigaction old_sigchld_action,
+    sigchld_action = { .sa_handler = handle_sigchld,
+		       .sa_flags = SA_NOCLDSTOP };
   sigemptyset(&sigchld_action.sa_mask);
   ret = sigaddset(&sigchld_action.sa_mask, SIGCHLD);
   if(ret < 0){
@@ -195,13 +193,7 @@
     { .name = "plugin-dir", .key = 128,
       .arg = "DIRECTORY",
       .doc = "Specify a different plugin directory", .group = 2 },
-    { .name = "userid", .key = 129,
-      .arg = "ID", .flags = 0,
-      .doc = "User ID the plugins will run as", .group = 2 },
-    { .name = "groupid", .key = 130,
-      .arg = "ID", .flags = 0,
-      .doc = "Group ID the plugins will run as", .group = 2 },
-    { .name = "debug", .key = 131,
+    { .name = "debug", .key = 129,
       .doc = "Debug mode", .group = 3 },
     { .name = NULL }
   };
@@ -242,12 +234,6 @@
       plugindir = arg;
       break;
     case 129:
-      uid = (uid_t)strtol(arg, NULL, 10);
-      break;
-    case 130:
-      gid = (gid_t)strtol(arg, NULL, 10);
-      break;
-    case 131:
       debug = true;
       break;
     case ARGP_KEY_ARG:
@@ -267,8 +253,8 @@
 		       .args_doc = "",
 		       .doc = "Mandos plugin runner -- Run plugins" };
   
-  argp_parse (&argp, argc, argv, 0, 0, &plugin_list);  
-
+  argp_parse (&argp, argc, argv, 0, 0, &plugin_list);
+  
   if(debug){
     for(plugin *p = plugin_list; p != NULL; p=p->next){
       fprintf(stderr, "Plugin: %s has %d arguments\n",
@@ -278,16 +264,6 @@
       }
     }
   }
-
-  ret = setuid(uid);
-  if (ret == -1){
-    perror("setuid");
-  }
-  
-  setgid(gid);
-  if (ret == -1){
-    perror("setuid");
-  }
   
   dir = opendir(plugindir);
   if(dir == NULL){

=== modified file 'plugins.d/mandosclient.c'
--- plugins.d/mandosclient.c	2008-08-02 15:47:42 +0000
+++ plugins.d/mandosclient.c	2008-08-01 06:33:15 +0000
@@ -37,8 +37,6 @@
 #include <stdlib.h>
 #include <time.h>
 #include <net/if.h>		/* if_nametoindex */
-#include <sys/ioctl.h> 		// ioctl, ifreq, SIOCGIFFLAGS, IFF_UP, SIOCSIFFLAGS
-#include <net/if.h> 		// ioctl, ifreq, SIOCGIFFLAGS, IFF_UP, SIOCSIFFLAGS
 
 #include <avahi-core/core.h>
 #include <avahi-core/lookup.h>
@@ -71,9 +69,9 @@
 #define BUFFER_SIZE 256
 #define DH_BITS 1024
 
-static const char *certdir = "/conf/conf.d/mandos";
-static const char *certfile = "openpgp-client.txt";
-static const char *certkey = "openpgp-client-key.txt";
+const char *certdir = "/conf/conf.d/cryptkeyreq/";
+const char *certfile = "openpgp-client.txt";
+const char *certkey = "openpgp-client-key.txt";
 
 bool debug = false;
 
@@ -84,9 +82,8 @@
 } encrypted_session;
 
 
-static ssize_t pgp_packet_decrypt (char *packet, size_t packet_size,
-				   char **new_packet,
-				   const char *homedir){
+ssize_t pgp_packet_decrypt (char *packet, size_t packet_size,
+			    char **new_packet, const char *homedir){
   gpgme_data_t dh_crypto, dh_plain;
   gpgme_ctx_t ctx;
   gpgme_error_t rc;
@@ -248,12 +245,12 @@
   return ret;
 }
 
-static void debuggnutls(__attribute__((unused)) int level,
-			const char* string){
+void debuggnutls(__attribute__((unused)) int level,
+		 const char* string){
   fprintf(stderr, "%s", string);
 }
 
-static int initgnutls(encrypted_session *es){
+int initgnutls(encrypted_session *es){
   const char *err;
   int ret;
   
@@ -347,11 +344,11 @@
   return 0;
 }
 
-static void empty_log(__attribute__((unused)) AvahiLogLevel level,
-		      __attribute__((unused)) const char *txt){}
+void empty_log(__attribute__((unused)) AvahiLogLevel level,
+	       __attribute__((unused)) const char *txt){}
 
-static int start_mandos_communication(const char *ip, uint16_t port,
-				      AvahiIfIndex if_index){
+int start_mandos_communication(const char *ip, uint16_t port,
+			       AvahiIfIndex if_index){
   int ret, tcp_sd;
   struct sockaddr_in6 to;
   encrypted_session es;
@@ -374,15 +371,15 @@
     perror("socket");
     return -1;
   }
-
+  
+  if(if_indextoname((unsigned int)if_index, interface) == NULL){
+    if(debug){
+      perror("if_indextoname");
+    }
+    return -1;
+  }
+  
   if(debug){
-    if(if_indextoname((unsigned int)if_index, interface) == NULL){
-      if(debug){
-	perror("if_indextoname");
-      }
-      return -1;
-    }
-    
     fprintf(stderr, "Binding to interface %s\n", interface);
   }
   
@@ -630,23 +627,19 @@
     }
 }
 
-/* Combines file name and path and returns the malloced new
-   string. some sane checks could/should be added */
-static const char *combinepath(const char *first, const char *second){
-  size_t f_len = strlen(first);
-  size_t s_len = strlen(second);
-  char *tmp = malloc(f_len + s_len + 2);
+/* combinds file name and path and returns the malloced new string. som sane checks could/should be added */
+const char *combinepath(const char *first, const char *second){
+  char *tmp;
+  tmp = malloc(strlen(first) + strlen(second) + 2);
   if (tmp == NULL){
+    perror("malloc");
     return NULL;
   }
-  if(f_len > 0){
-    memcpy(tmp, first, f_len);
-  }
-  tmp[f_len] = '/';
-  if(s_len > 0){
-    memcpy(tmp + f_len + 1, second, s_len);
-  }
-  tmp[f_len + 1 + s_len] = '\0';
+  strcpy(tmp, first);
+  if (first[0] != '\0' and first[strlen(first) - 1] != '/'){
+    strcat(tmp, "/");
+  }
+  strcat(tmp, second);
   return tmp;
 }
 
@@ -657,11 +650,9 @@
     int error;
     int ret;
     int returncode = EXIT_SUCCESS;
-    const char *interface = "eth0";
-    struct ifreq network;
-    int sd;
+    const char *interface = NULL;
+    AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
     char *connect_to = NULL;
-    AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
     
     while (true){
       static struct option long_options[] = {
@@ -703,25 +694,18 @@
 	exit(EXIT_FAILURE);
       }
     }
-    
+
     certfile = combinepath(certdir, certfile);
     if (certfile == NULL){
-      perror("combinepath");
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-
-    certkey = combinepath(certdir, certkey);
-    if (certkey == NULL){
-      perror("combinepath");
-      returncode = EXIT_FAILURE;
       goto exit;
     }
     
-    if_index = (AvahiIfIndex) if_nametoindex(interface);
-    if(if_index == 0){
-      fprintf(stderr, "No such interface: \"%s\"\n", interface);
-      exit(EXIT_FAILURE);
+    if(interface != NULL){
+      if_index = (AvahiIfIndex) if_nametoindex(interface);
+      if(if_index == 0){
+	fprintf(stderr, "No such interface: \"%s\"\n", interface);
+	exit(EXIT_FAILURE);
+      }
     }
     
     if(connect_to != NULL){
@@ -748,30 +732,10 @@
       }
     }
     
-    sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-    if(sd < 0) {
-      perror("socket");
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-    strcpy(network.ifr_name, interface);    
-    ret = ioctl(sd, SIOCGIFFLAGS, &network);
-    if(ret == -1){
-      
-      perror("ioctl SIOCGIFFLAGS");
-      returncode = EXIT_FAILURE;
-      goto exit;
-    }
-    if((network.ifr_flags & IFF_UP) == 0){
-      network.ifr_flags |= IFF_UP;
-      ret = ioctl(sd, SIOCSIFFLAGS, &network);
-      if(ret == -1){
-	perror("ioctl SIOCSIFFLAGS");
-	returncode = EXIT_FAILURE;
-	goto exit;
-      }
-    }
-    close(sd);
+    certkey = combinepath(certdir, certkey);
+    if (certkey == NULL){
+      goto exit;
+    }
     
     if (not debug){
       avahi_set_log_function(empty_log);
@@ -783,7 +747,7 @@
     /* Allocate main loop object */
     if (!(simple_poll = avahi_simple_poll_new())) {
         fprintf(stderr, "Failed to create simple poll object.\n");
-	returncode = EXIT_FAILURE;	
+	
         goto exit;
     }
 

